# Generated by Django 3.2.6 on 2022-03-08 11:55

from django.conf import settings
import django.contrib.gis.db.models.fields
from django.db import migrations, models
import django.db.models.deletion
import smartwater.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('documents', '0003_auto_20171115_0936'),
    ]

    operations = [
        migrations.CreateModel(
            name='Annotation',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('target_type', models.CharField(choices=[('question', 'Question'), ('choice', 'Choice'), ('observation', 'Observation'), ('answer', 'Answer'), ('annotation', 'Annotation')], max_length=12)),
                ('target_id', models.IntegerField()),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Collect',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('title', models.CharField(max_length=512)),
                ('description', models.TextField()),
                ('status', models.CharField(choices=[('DR', 'Draft'), ('PU', 'Published')], default='DR', max_length=2)),
                ('main_question', models.CharField(max_length=512)),
                ('short_description', models.CharField(max_length=512)),
                ('image', models.ImageField(upload_to=smartwater.models.collect_image_path)),
                ('geom', django.contrib.gis.db.models.fields.MultiPolygonField(srid=31370)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Question',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('title', models.CharField(max_length=512)),
                ('description', models.TextField()),
                ('kind', models.CharField(choices=[('R', 'Observer'), ('D', 'Observed')], max_length=1)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Robot',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('name', models.CharField(max_length=512)),
                ('code', models.CharField(max_length=64)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TextAnnotation',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('text', models.TextField()),
                ('annotation', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='text', to='smartwater.annotation')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='QuestionLink',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('order', models.IntegerField(default=1)),
                ('collect', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='smartwater.collect')),
                ('question', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='smartwater.question')),
            ],
        ),
        migrations.AddField(
            model_name='question',
            name='link',
            field=models.ManyToManyField(through='smartwater.QuestionLink', to='smartwater.Collect'),
        ),
        migrations.CreateModel(
            name='Observation',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('session', models.CharField(max_length=40)),
                ('observed_point', django.contrib.gis.db.models.fields.PointField(srid=4326)),
                ('collect', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='smartwater.collect')),
                ('user', models.ForeignKey(blank=None, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ImageAnnotation',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('annotation', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='image', to='smartwater.annotation')),
                ('image', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='documents.image')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Community',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('title', models.CharField(max_length=512)),
                ('description', models.TextField()),
                ('geom', django.contrib.gis.db.models.fields.MultiPolygonField(srid=31370)),
                ('collects', models.ManyToManyField(to='smartwater.Collect')),
                ('contact', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to=settings.AUTH_USER_MODEL)),
                ('robots', models.ManyToManyField(to='smartwater.Robot')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='CollectCategory',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('title', models.CharField(max_length=512)),
                ('description', models.TextField()),
                ('collects', models.ManyToManyField(related_name='categories', to='smartwater.Collect')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Choice',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('title', models.CharField(max_length=512)),
                ('description', models.TextField()),
                ('order', models.IntegerField(default=1)),
                ('question', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='smartwater.question')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Answer',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('choice', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='smartwater.choice')),
                ('observation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='smartwater.observation')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='annotation',
            name='collect',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='smartwater.collect'),
        ),
        migrations.AddField(
            model_name='annotation',
            name='user',
            field=models.ForeignKey(blank=None, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddConstraint(
            model_name='questionlink',
            constraint=models.UniqueConstraint(fields=('collect', 'question'), name='question_link_constraint'),
        ),
    ]
